<?php
// WebJaxe, Observatoire de Paris, licence GPL
// encodage : UTF-8

// affiche la page pour la gestion des projets
// nécessite tete_pied.php, projets.php, et l'initialisation des strings et des erreurs
function page_administration_projets() {

    $liste_projets = liste_des_projets();
    
    debut_html(GESTION_PROJETS, GESTION_PROJETS);
    if ($liste_projets != FALSE) {
        echo '<table cellpadding="6" cellspacing="0" border="1" class="table_administration">'."\n";
        echo '<tr><th>'.NOM.'</th><th colspan="4">'.ACTIONS.'</th></tr>'."\n";
        for ($i=0; $i<count($liste_projets); $i++)
        {
            $projet = $liste_projets[$i];
            $id_projet = $projet['id'];
            $titre_projet = $projet['titre'];
            echo "<tr>\n";
            echo '<td><b>'.$titre_projet."</b></td>\n";
            echo '<td><a href="administration.php?page=modifier_projet&amp;id_projet='.$id_projet.'" class="petit_bouton">';
            echo '<img src="../../design/icones/editer.gif" class="icone" border="0"> '.RENOMMER."</a></td>\n";
            echo '<td><a href="administration.php?page=gestion_des_contributions&amp;id_projet='.$id_projet.'" class="petit_bouton">';
            echo '<img src="../../design/icones/contributions_small.gif" class="icone" border="0"> '.CONTRIBUTIONS."</a></td>\n";
            echo '<td><a href="administration.php?page=participants_projet&amp;id_projet='.$id_projet.'" class="petit_bouton">';
            echo '<img src="../../design/icones/utilisateurs_small.gif" class="icone" border="0"> '.PARTICIPANTS."</a></td>\n";
            $liste_contributions = liste_id_contributions_projet($id_projet);
            if ($liste_contributions == false || count($liste_contributions) == 0) {
                echo '<td><a href="administration.php?action=supprimer_projet&amp;id='.$id_projet.'" class="petit_bouton">';
                echo '<img src="../../design/icones/poubelle.gif" class="icone" border="0"> '.SUPPRIMER."</a></td>\n";
            } else {
                echo "<td></td>\n";
            }
            echo "</tr>\n";
        }
        echo "</table>\n";
    }
    
    // formulaire pour ajouter un projet
    echo '<div class="formulaire">'."\n";
    echo '<p class="soustitre">'.TITRE_AJOUTER_PROJET.'</p>'."\n";
    echo '<form method="POST" action="administration.php">'."\n";
    echo '<input type="hidden" name="action" value="ajouter_projet">'."\n";
    echo '<input type="text" name="titre_projet" class="texte" size="40" maxlength="40">';
    echo '<input type="submit" name="ajouter" value="'.AJOUTER.'" class="valider">';
    echo "</form>\n";
    echo "</div>\n"; // formulaire
    
    echo '<p><a href="administration.php?page=accueil">'.RETOUR."</a></p>\n";
    
    fin_html();
}

// Ajoute un projet à partir de son titre dans une requête POST
function action_ajouter_projet() {
    if (!isset($_POST['titre_projet']))
        erreur(PARAMETRES_MANQUANT);
    $titre_projet = $_POST['titre_projet'];
    
    creer_projet($titre_projet);
    page_administration_projets();
}


// Supprime un projet à partir de son id dans une requête GET
function action_supprimer_projet() {
    
    if (!isset($_GET['id']))
        erreur(PARAMETRES_MANQUANT);
    $id_projet = $_GET['id'];
    verifie_id($id_projet);
    
    supprimer_projet($id_projet);
    page_administration_projets();
}


?>
