<?php
// WebJaxe, Observatoire de Paris, licence GPL
// encodage : UTF-8

// vérifie si la structure de la base de données est à jour
// nécessite base_de_donnees.php, et l'initialisation des strings et des erreurs
// renvoit true si c'est à jour, false sinon (auquel cas il faut probablement appeler maj_bdd)
function verif_bdd_1($lien_bdd) {
    $requete = "SHOW COLUMNS FROM contributions";
    $resultat = executer_requete($requete, $lien_bdd);
    $champs = lire_le_resultat($resultat, "Field");
    for ($i=0; $i<count($champs); $i++) {
        if ($champs[$i] == "nom")
            return(true);
        else if ($champs[$i] == "nom_contribution")
            return(false);
    }
    deconnecte_base($lien_bdd);
    erreur("impossible de vérifier la structure de la base de données");
}

function verif_bdd() {
    $requete = "SHOW COLUMNS FROM contributions";
    $resultat = executer_requete($requete);
    if (!tester_resultat($resultat)) {
        erreur("impossible de vérifier la structure de la base de données");
    }
    $champs = lire_le_resultat($resultat, "Field");
    for ($i=0; $i<count($champs); $i++) {
        if ($champs[$i] == "id_projet")
            return(true);
    }
    return(false);
}

// met à jour la structure de la base de données
function maj_bdd() {
    $lien_bdd = connexion();
    // si nécessaire : ALTER TABLE contributions ADD config VARCHAR(20) NOT NULL;
    // suivi de : UPDATE contributions SET config="$_SESSION['chemin_configuration_jaxe']";
    if (!verif_bdd_1($lien_bdd)) {
        // vérif des liens
        $requete = "SELECT contributeurs.login FROM contributeurs LEFT JOIN utilisateurs ON contributeurs.login=utilisateurs.login WHERE utilisateurs.login IS NULL";
        $resultat = executer_requete($requete, $lien_bdd);
        if (nombre_de_lignes($resultat) > 0) {
            $table = lire_le_resultat($resultat, 'login');
            $liste = "";
            for ($i=0; $i<count($table); $i++)
                $liste .= ' '.$table[$i];
            deconnecte_base($lien_bdd);
            erreur('bdd incohérente: contributeurs.login non trouvés dans la table utilisateurs: '.$liste);
        }
        
        // nettoyage de edition_contributions
        requete_modif("DELETE edition_contributions.* FROM edition_contributions LEFT JOIN contributions ON contributions.nom_contribution=edition_contributions.nom_contribution WHERE contributions.nom_contribution IS NULL", $lien_bdd);
        
        // modifs structure
        requete_modif("ALTER TABLE contributions CHANGE COLUMN nom_contribution nom varchar(30) NOT NULL;", $lien_bdd);
        requete_modif("ALTER TABLE contributeurs DROP COLUMN id;", $lien_bdd);
        requete_modif("ALTER TABLE contributeurs CHANGE COLUMN id_projet id_contribution int(6) NOT NULL;", $lien_bdd);
        requete_modif("ALTER TABLE contributeurs ADD COLUMN id_utilisateur int(5) NOT NULL;", $lien_bdd);
        requete_modif("ALTER TABLE edition_contributions ADD COLUMN id_utilisateur int(5) NOT NULL;", $lien_bdd);
        requete_modif("ALTER TABLE edition_contributions ADD COLUMN id_contribution int(6) NOT NULL;", $lien_bdd);
        requete_modif("ALTER TABLE edition_contributions DROP PRIMARY KEY;", $lien_bdd);
        
        requete_modif("UPDATE contributeurs, utilisateurs SET contributeurs.id_utilisateur=utilisateurs.id WHERE utilisateurs.login=contributeurs.login", $lien_bdd);
        
        requete_modif("UPDATE edition_contributions, utilisateurs SET edition_contributions.id_utilisateur=utilisateurs.id WHERE utilisateurs.login=edition_contributions.login_utilisateur", $lien_bdd);
        
        requete_modif("UPDATE edition_contributions, contributions SET edition_contributions.id_contribution=contributions.id WHERE contributions.nom=edition_contributions.nom_contribution", $lien_bdd);
        
        requete_modif("ALTER TABLE contributeurs DROP COLUMN login;", $lien_bdd);
        requete_modif("ALTER TABLE edition_contributions DROP COLUMN login_utilisateur;", $lien_bdd);
        requete_modif("ALTER TABLE edition_contributions DROP COLUMN nom_contribution;", $lien_bdd);
    }
    
    requete_modif("CREATE TABLE projets (id int(5) NOT NULL auto_increment, titre varchar(40) NOT NULL, PRIMARY KEY (id) )", $lien_bdd);
    requete_modif("CREATE TABLE participants (id_utilisateur int(5) NOT NULL, id_projet int(5) NOT NULL)", $lien_bdd);
    requete_modif("ALTER TABLE contributions ADD COLUMN id_projet int(5) NOT NULL;", $lien_bdd);
    requete_modif("ALTER TABLE contributions ADD COLUMN id_dernier_utilisateur int(5);", $lien_bdd);
    requete_modif("ALTER TABLE contributions ADD COLUMN date_edition DATETIME;", $lien_bdd);
    requete_modif("UPDATE contributions, edition_contributions SET contributions.id_dernier_utilisateur=edition_contributions.id_utilisateur WHERE edition_contributions.id_contribution=contributions.id", $lien_bdd);
    requete_modif("UPDATE contributions, edition_contributions SET contributions.date_edition=edition_contributions.date WHERE edition_contributions.id_contribution=contributions.id", $lien_bdd);
    
    $no_projet = 1;
    $requete = "SELECT id FROM contributions";
    $resultat_requete = executer_requete($requete, $lien_bdd);
    if (!tester_resultat($resultat_requete)) {
        deconnecte_base($lien_bdd);
        erreur(REQUETE_LISTE_CONTRIBUTION);
    }
    $liste_contributions = lire_le_resultat($resultat_requete, 'id');
    
    if ($liste_contributions != FALSE) {
        // pour chaque contribution
        for ($i=0; $i<count($liste_contributions); $i++) {
            $id_contribution = $liste_contributions[$i];
            $requete ="SELECT id_utilisateur FROM contributeurs WHERE id_contribution='$id_contribution' ORDER BY id_utilisateur";
            $resultat_requete = executer_requete($requete, $lien_bdd);
            if (!tester_resultat($resultat_requete)) {
                deconnecte_base($lien_bdd);
                erreur(ECHEC_REQUETE.' '.$requete);
            }
            $liste_utilisateurs_contrib = lire_le_resultat($resultat_requete, 'id_utilisateur');
            
            // recherche d'un projet avec les mêmes utilisateurs
            $trouve = false;
            $requete ="SELECT id FROM projets";
            $resultat_requete = executer_requete($requete, $lien_bdd);
            if (!tester_resultat($resultat_requete)) {
                deconnecte_base($lien_bdd);
                erreur(ECHEC_REQUETE.' '.$requete);
            }
            $liste_projets = lire_le_resultat($resultat_requete, 'id');
            for ($j=0; $j<count($liste_projets); $j++) {
                $id_projet = $liste_projets[$j];
                $requete ="SELECT id_utilisateur FROM participants WHERE id_projet='$id_projet' ORDER BY id_utilisateur";
                $resultat_requete = executer_requete($requete, $lien_bdd);
                if (!tester_resultat($resultat_requete)) {
                    deconnecte_base($lien_bdd);
                    erreur(ECHEC_REQUETE.' '.$requete);
                }
                $liste_utilisateurs_projet = lire_le_resultat($resultat_requete, 'id_utilisateur');
                if ($liste_utilisateurs_contrib == $liste_utilisateurs_projet) {
                    $trouve = true;
                    break;
                }
            }
            if (!$trouve) {
                // création d'un nouveau projet
                requete_modif("INSERT INTO projets (titre) VALUES ('projet $no_projet')", $lien_bdd);
                $id_projet = dernier_id($lien_bdd);
                requete_modif("INSERT INTO participants (id_utilisateur, id_projet) SELECT contributeurs.id_utilisateur, '$id_projet' FROM contributeurs WHERE id_contribution='$id_contribution'", $lien_bdd);
                $no_projet = $no_projet + 1;
            }
            // ajout du lien
            requete_modif("UPDATE contributions SET id_projet='$id_projet' WHERE id='$id_contribution'", $lien_bdd);
        }
    }
    requete_modif("DROP table edition_contributions;", $lien_bdd);
    requete_modif("DROP table contributeurs;", $lien_bdd);
    
    debut_html(PARAMETRE_WEBJAXE, PARAMETRE_WEBJAXE);
    echo '<p>'.BDD_MAJ.'</p>';
    echo '<p><a href="partie_administrateur/administration.php?page=accueil">Continuer</a></p>';
    fin_html();
}

function requete_modif($requete, $lien_bdd) {
    if (!tester_resultat(executer_requete($requete, $lien_bdd))) {
        deconnecte_base($lien_bdd);
        erreur(ECHEC_REQUETE." (".$requete.")");
    }
}

function verif_historiques() {
    $base = $_SESSION['nom_base_de_donnes'];
    $requete = "SHOW TABLES FROM ".$base." LIKE 'historiques'";
    $resultat = executer_requete($requete);
    if (!tester_resultat($resultat) /*|| mysql_num_rows($resultat) == 0*/) {
        erreur("impossible de vérifier la table historiques");
    }
    if (lire_le_resultat($resultat))
        return(true);
    
    return(false);
}

?>
