<?php
// WebJaxe, Observatoire de Paris, licence GPL
// encodage : UTF-8

// affiche la page listant les contributions de l'utilisateur
// nécessite tete_pied.php, contributions.php, base_de_donnees.php, utilisateurs.php
// et l'initialisation des strings et des erreurs
function page_liste_contributions() {

    $id_utilisateur = $_SESSION['id_utilisateur'];
    debut_html(LISTE_CONTRIBUTIONS, LISTE_CONTRIBUTIONS);
    
    $dossier_sites = $_SESSION['chemin_dossier_apercu'];
    $liste_projets = liste_des_projets_utilisateur($id_utilisateur);
    
    if ($liste_projets != FALSE) {
        for ($i=0; $i<count($liste_projets); $i++) {
            $projet = $liste_projets[$i];
            $id_projet = $projet['id'];
            $titre_projet = $projet['titre'];
            $liste_contributions = liste_des_contributions_projet($id_projet);
            echo '<p class="soustitre">'.PROJET.' <em>'.$titre_projet.'</em>';
            if ($liste_contributions == false || count($liste_contributions) == 0) {
                echo ' <a href="index.php?action=supprimer_projet&amp;id='.$id_projet.'" class="petit_bouton">';
                echo '<img src="../../design/icones/poubelle.gif" class="icone" border="0"> '.SUPPRIMER.'</a>';
            } else {
                echo ' <a href="index.php?action=exporter_projet&amp;id='.$id_projet.'" class="petit_bouton">';
                echo '<img src="../../design/icones/telecharger.gif" class="icone" border="0"> '.EXPORTER.'</a>';
            }
            echo "</p>\n";
            if ($liste_contributions != FALSE) {
                echo '<div class="listecontribution">'."\n";
                echo '<table width="100%" border="1" cellpadding="0" cellspacing="0">'."\n";
                for ($j=0; $j<count($liste_contributions); $j++) {
                    $contribution = $liste_contributions[$j];
                    $id_contribution = $contribution['id'];
                    $nom_contribution = $contribution['nom'];
                    echo '<tr><td align="center">';
                    echo "<a href=\"index.php?page=edition_contribution&amp;id_contribution=$id_contribution\" class=\"contribution\">$nom_contribution</a>";
                    echo "</td><td align=\"center\">\n";
                    //echo "<a href=\"index.php?page=edition_contribution&amp;id_contribution=$id_contribution\" title=\"".EDITER_CONTRIBUTION."\"><img src=\"../../design/icones/editer.gif\" alt=\"".EDITER_CONTRIBUTION."\" border=\"0\"></a> &nbsp;";
                	if (is_file("../../".$dossier_sites."/".$nom_contribution."/index.html"))
                	   echo " <a href=\"../../".$dossier_sites."/".$nom_contribution."/index.html\" title=\"".VOIR_APERCU."\"><img src=\"../../design/icones/site.gif\" alt=\"".APERCU."\" border=\"0\"></a>";
                    echo "</td></tr>\n";
                }
                echo "</table>\n";
                echo "</div>\n"; // listecontribution
            }
            echo "<br>\n";
        }
    }
    
    fin_html();
}

// Supprime un projet à partir de son id dans une requête GET
function action_supprimer_projet() {
    if (!isset($_GET['id']))
        erreur(PARAMETRES_MANQUANT);
    $id_projet= $_GET['id'];
    $id_utilisateur = $_SESSION['id_utilisateur'];
    
    if (!est_participant($id_projet, $id_utilisateur))
        erreur(PAS_AUTORISE);
    $liste_contributions = liste_des_contributions_projet($id_projet);
    if ($liste_contributions != false && count($liste_contributions) != 0)
        erreur(PAS_AUTORISE);
    if (supprimer_projet($id_projet))
        page_liste_contributions();
}

// Export en zip de toutes les contributions d'un projet
function action_exporter_projet() {
    if (!isset($_GET['id']))
        erreur(PARAMETRES_MANQUANT);
    
    $id_utilisateur = $_SESSION['id_utilisateur'];
    $id_projet = $_GET['id'];
    if (!est_participant($id_projet, $id_utilisateur))
        erreur(PAS_AUTORISE);
    
    $nom_projet = strtr(utf8_decode(titre_projet($id_projet)), utf8_decode('éèàêïë '), 'eeaeie_');
    $sep = DIRECTORY_SEPARATOR;
    $racine = realpath(getcwd().$sep.'..'.$sep.'..'.$sep).$sep;
    $dossier_temp = $racine.'tmp';
    $tmpzip = tempnam($dossier_temp, 'tmpzip_'.$nom_projet);
    $archive = new PclZip($tmpzip);
    $contrib_xml = $racine.'contribXML';
    $liste_contributions = liste_des_contributions_projet($id_projet);
    $liste_noms_contributions = array();
    for ($i=0; $i<count($liste_contributions); $i++) {
        $contribution = $liste_contributions[$i];
        $nom_contribution = $contribution['nom'];
        $liste_noms_contributions[] = $contrib_xml.$sep.$nom_contribution;
    }
    $v_list = $archive->add($liste_noms_contributions, PCLZIP_OPT_REMOVE_PATH, $contrib_xml, PCLZIP_OPT_ADD_PATH, $nom_projet);
    if ($v_list == 0)
        erreur($archive->errorInfo(true));
    if (!file_exists($tmpzip))
        erreur(CONTACTER_ADMIN);
    
    header('Content-Type: application/octet-stream');
    header('Content-Disposition: attachment; filename='.$nom_projet.'.zip');
    header('Content-Transfer-Encoding: binary');
    header('Expires: 0');
    header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
    header('Pragma: public');
    header('Content-Length: ' . filesize($tmpzip));
    ob_clean();
    flush();
    readfile($tmpzip);
    unlink($tmpzip);
    exit;
}

?>
